﻿package {
	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.utils.Timer;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import Balloon;

	public class Main extends MovieClip {
		private var textio_xml:XML = new XML();
		private const XML_REQUEST:URLRequest = new URLRequest( "textio.xml" );
		private var XMLLoader:URLLoader;
		// Timer用
		private var pCounter:int = 0;
		private var timerObj:Timer;
		// Bolloon保持
		private var balloons:Array = new Array();
		// 上昇回数
		private var loopCount = 6;
	  
		function Main() {
			// XML読み込み用
			XMLLoader = new URLLoader( XML_REQUEST );
			XMLLoader.addEventListener( Event.COMPLETE, xmlLoaded );
		}
	
		function xmlLoaded(e:Event):void {
			textio_xml = XML( XMLLoader.data );
			timerObj = new Timer( 1 ,1 );
			timerObj.addEventListener( TimerEvent.TIMER, onTick );
			makeBalloon();
		}
	
		function onTick(e:TimerEvent):void {
			loopCount = 6;
			addEventListener( Event.ENTER_FRAME, upBalloon );
		}

		function makeBalloon():void {
			var counter:int = timerObj.currentCount;
			var curP:XML = textio_xml.act[ 0 ].p[ counter ];
			if ( curP == null ) return;
			var word:String = curP.toString();
			var direction:String = curP.@name.toString();
			var balloon:Balloon = new Balloon( word, direction );
			addChild( balloon);
			balloons.push( balloon );
			timerObj.delay = curP.toString().length * 100;
			timerObj.start();
		}
		
		function upBalloon( e:Event ):void {
			if( loopCount--  ) {
				for( var i:int; i < balloons.length; i++ ) {
					balloons[ i ].y -= 5;
				}
			} else {
				removeEventListener( Event.ENTER_FRAME, upBalloon );
				makeBalloon();
			}
		}
	}
}